function [qq,qmc] = evalq(betasim,etasim,sigsim,betamcmc,etamcmc,sigmcmc,etapost,betapostm,betapostchol,sigpost);

MMC=size(etapost,3);
L=size(etasim,3);
nst=size(etasim,1);
qmall=zeros(L,MMC);
qqall=zeros(L,MMC);

for l=1:MMC
  %l
      infcholbeta=inv(squeeze(betapostchol(:,:,l))); %sigma^-1=infchol'*infchol
      
      qmall(:,l) = qmall(:,l) + pmultnormsigchol(betamcmc,squeeze(betapostm(:,l*ones(1,L))),infcholbeta)';
      qmall(:,l) = qmall(:,l) + squeeze(dirichlog(etamcmc,etapost(:,:,l*ones(1,L))));
      qmall(:,l) = qmall(:,l) + prodinvgamlog(sigmcmc,sigpost(:,:,l*ones(1,L)))';
      
      qqall(:,l) = qqall(:,l) + pmultnormsigchol(betasim,squeeze(betapostm(:,l*ones(1,L))),infcholbeta)';
      qqall(:,l) = qqall(:,l) + squeeze(dirichlog(etasim,etapost(:,:,l*ones(1,L))));
      qqall(:,l) = qqall(:,l) + prodinvgamlog(sigsim,sigpost(:,:,l*ones(1,L)))';
                     
     end

qmax= max(qmall,[],2);
qmc=qmax+log(sum(exp(max(qmall-qmax(:,ones(1,MMC)),-1e15*ones(L,MMC))),2));

qmax= max(qqall,[],2);
qq= qmax+log(sum(exp(max(qqall-qmax(:,ones(1,MMC)),-1e15*ones(L,MMC))),2));

qmc=qmc-log(MMC);
qq=qq-log(MMC);
