function [fv,sp] = filtvert3(y,Z,eta,pini,mu,betay,betam,sig);

% FILTVERT filterverteilung
% function call

p = pini;
n = length(y)+1;
fv = zeros(n,length(pini));
fv(1,:) = pini';
sp = 0;

for i = 2:n
    ext = eta'*p;
    [lh  maxl] = likeli3(y(i-1),Z(i-1,:),mu,betay,betam,sig);    % use likelihood function
    p = ext.*lh;
    sp = sp + log(sum(p))+maxl;
    p = p / sum(p);
    fv(i,:) = p';
end

