function fd = prodinvgamlog(theta,par)

%input: theta ... einzel argument : spaltenvektor anzahl der zeilen=anzahl der produkte
%                 mehrere argumente: matrix, anzahl der spalten = zahl der argumente
%       par ... parameter
%       par(k,1), par(k,2) ... entspricht j.ter komponente von theta
%output: log of density
if size(theta,1)>1;
alpha = squeeze(par(:,1,:));
beta = squeeze(par(:,2,:));
else
alpha = squeeze(par(:,1,:))';
beta = squeeze(par(:,2,:))';
end
fd=sum(alpha.*log(beta)-gammaln(alpha)-beta./theta-(alpha+1).*log(theta),1);

