function [mu,betay,betam,Zmat,par,bmean,bvar]=simparinfo(y,Z,ylag,mlag,sst,sig,prbem,prbeinf);

nst=size(sig,1);
states=1:nst;
n=size(y,1);
nlsvar=mlag;
npar=nst+ylag+nlsvar*nst;
S=(sst(ones(1,nst),2:end)==states(ones(1,n),:)')';

w=(S*sig).^(-1);
W=diag(w);
Zmat=[S Z(:,2:ylag+1)];
for i=1:nst;
    Zmat=[Zmat Z(:,ylag+2:end).*squeeze(S(:,i,ones(1,nlsvar)))];
end
bvar=inv(Zmat'*W*Zmat+prbeinf);
bmean=bvar*(Zmat'*W*y+prbeinf*prbem);
par=bmean+ chol(bvar)'*randn(npar,1);
mu=par(1:nst);
betay=par(nst+1:nst+ylag);
betam=reshape(par(nst+ylag+1:end),mlag,nst);
