%file=eingeben;
fid=fopen(file,'w');
t='\\begin{table}\\caption{ }\\label{tab: }\\begin{center}\\begin{tabular}{ } \\hline \\hline \n';
fprintf(fid,t);
conm=ceil((it-it0)/100*50.0);
conl=ceil((it-it0)/100*2.5);
conu=floor((it-it0)/100*97.5);
nst=size(musim,1);
t=['par& mean& sd& median&\\multicolumn{2}{c}{95\\%% conf.int.}\\\\ \\hline \n'];
fprintf(fid,t);
srt=sort(musim(:,it0+1:it),2);
par=musim(:,it0+1:it)';
for i=1:nst
t=['$\\mu_' int2str(i) '$&' num2str(mean(musim(i,it0+1:it)),'%6.4f') '&' num2str(std(musim(i,it0+1:it)),'%6.4f') '&'...
     num2str(srt(i,conm),'%6.4f') '&' num2str(srt(i,conl),'%6.4f') '&' num2str(srt(i,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end

dim=size(betaysim,3);
lags=size(betaysim,1);
if dim>1; srt=sort(betaysim(:,:,it0+1:it),3); 
          dim=size(betaysim,2);
for j=1:dim;
for i=1:lags;
t=['$\\beta_{y' int2str(j) ',' int2str(i) '}$&' num2str(mean(betaysim(i,j,it0+1:it)),'%6.4f') '&' num2str(std(betaysim(i,j,it0+1:it)),'%6.4f') '&'...
     num2str(srt(i,j,conm),'%6.4f') '&' num2str(srt(i,j,conl),'%6.4f') '&' num2str(srt(i,j,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
par=[par squeeze(betaysim(:,j,it0+1:it))'];
end
else srt=sort(betaysim(:,it0+1:it),2); 
for i=1:lags;
t=['$\\beta_{y' int2str(i) '}$&' num2str(mean(betaysim(i,it0+1:it)),'%6.4f') '&' num2str(std(betaysim(i,it0+1:it)),'%6.4f') '&'...
     num2str(srt(i,conm),'%6.4f') '&' num2str(srt(i,conl),'%6.4f') '&' num2str(srt(i,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
par=[par betaysim(:,it0+1:it)'];
end

dim=size(betamsim,2);
lags=size(betamsim,1);
srt=sort(betamsim(:,:,it0+1:it),3);
if dim>1;  
for j=1:dim;
for i=1:lags;
t=['$\\beta_{m' int2str(j) ',' int2str(i) '}$&' num2str(mean(betamsim(i,j,it0+1:it)),'%6.4f') '&' num2str(std(betamsim(i,j,it0+1:it)),'%6.4f') '&'...
     num2str(srt(i,j,conm),'%6.4f') '&' num2str(srt(i,j,conl),'%6.4f') '&' num2str(srt(i,j,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
if lags>1;
par=[par squeeze(betamsim(:,j,it0+1:it))'];
else 
par=[par squeeze(betamsim(:,j,it0+1:it))];
end
end
else  
for i=1:lags;
t=['$\\beta_{m' int2str(i) '}$&' num2str(mean(betamsim(i,1,it0+1:it)),'%6.4f') '&' num2str(std(betamsim(i,1,it0+1:it)),'%6.4f') '&'...
     num2str(srt(i,1,conm),'%6.4f') '&' num2str(srt(i,1,conl),'%6.4f') '&' num2str(srt(i,1,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
par=[par squeeze(betamsim(:,1,it0+1:it))'];
end

if lags>1;
   sbetamsim=sum(betamsim,1);
   srt=sort(sbetamsim(:,:,it0+1:it),3);
if dim>1;  
for j=1:dim;
t=['$\\beta_{m' int2str(j) '}$&' num2str(mean(sbetamsim(1,j,it0+1:it)),'%6.4f') '&' num2str(std(sbetamsim(1,j,it0+1:it)),'%6.4f') '&'...
     num2str(srt(1,j,conm),'%6.4f') '&' num2str(srt(1,j,conl),'%6.4f') '&' num2str(srt(1,j,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
else 
t=['$\\beta_{m}$&' num2str(mean(sbetamsim(1,1,it0+1:it)),'%6.4f') '&' num2str(std(sbetamsim(1,1,it0+1:it)),'%6.4f') '&'...
     num2str(srt(1,1,conm),'%6.4f') '&' num2str(srt(1,1,conl),'%6.4f') '&' num2str(srt(1,1,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
end
dim=size(sigsim,1);
srt=sort(sigsim(:,it0+1:it),2);
if dim>1;
for i=1:dim;
t=['$\\sigma_' int2str(i) '$&' num2str(mean(sigsim(i,it0+1:it)),'%6.4f') '&' num2str(std(sigsim(i,it0+1:it)),'%6.4f') '&'...
     num2str(srt(i,conm),'%6.4f') '&' num2str(srt(i,conl),'%6.4f') '&' num2str(srt(i,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
else
t=['$\\sigma$&' num2str(mean(sigsim(1,it0+1:it)),'%6.4f') '&' num2str(std(sigsim(1,it0+1:it)),'%6.4f') '&'...
     num2str(srt(1,conm),'%6.4f') '&' num2str(srt(1,conl),'%6.4f') '&' num2str(srt(1,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
end
par=[par sigsim(:,it0+1:it)'];

if nst>1;
srt=sort(etasim(:,:,it0+1:it),3);
for j=1:nst;
   for i=1:nst;
t=['$\\eta_{' int2str(j) int2str(i) '}$&' num2str(mean(etasim(j,i,it0+1:it)),'%6.4f') '&' num2str(std(etasim(j,i,it0+1:it)),'%6.4f') '&'...
     num2str(srt(j,i,conm),'%6.4f') '&' num2str(srt(j,i,conl),'%6.4f') '&' num2str(srt(j,i,conu),'%6.4f') '\\\\ \n'];
fprintf(fid,t);
   end
par=[par squeeze(etasim(j,:,it0+1:it))'];
end
end

t='\\hline \\hline \\end{tabular}\\end{center}\\end{table}\n';
fprintf(fid,t);

t=['loglik\n'];
fprintf(fid,t);
ll=max(loglik(it0+1:it));
fprintf(fid,'%8.4f \n',ll);
t=['schwarz\n'];
fprintf(fid,t);
sic=ll-size(par,2)/2*log(size(y,1));
fprintf(fid,'%8.4f \n',sic);

st=fclose(fid);
%[ac, hm, sd, ki, ineff] = autocovneu(par,1000);


